#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <ctype.h>
#include <ssdef.h>
#include <descrip.h>
#include "global.h"
#include "command.h"
#include "constants.h"
#include "window.h"
#include "extern.h"
#include "qio.h"

extern void user_set();
extern char userhost[], *g_body, *g_sent, *g_invite, *g_from;
extern int quit, sys$exit(), sys$setast();
extern win_ptr gwin, awins;
extern struct list_structs list_rpl, names_rpl;
extern void bind_typetext(char *string), user_exec(char *string), irc_receive();
extern server_ptr gsrv;
extern int clean_word(char **str, char *word), set_echo(int);
extern void ff_strncpy(char *str, char *start, int len, int max);

int old_display, flushing = FALSE;
char *flush_nick;

/* ------------------------------------------------------------------ */
extern void set_redirect(char *str, server_ptr srv), master_list();
extern char *next_arg(char **str);
extern win_ptr get_win_by_name(char *str);
/* ------------------------------------------------------------------ */
   void      user_window   (char *str);
/* ------------------------------------------------------------------ */
CmdList *exact_find_command (CmdList *clist, int omax, char *com)
{
  int j, min=0, max, pos, old_pos = -1;
 
  max = omax;
  while (1) {
    pos = (max + min) / 2;
    if (pos == old_pos) return (CmdList *)NULL;
    old_pos = pos;
    j = strcasecmp(com, clist[pos].command);
    if (j == 0) return &clist[pos];
    if (j < 0) max = pos-1;
    else min = pos+1;
  }
}

CmdList *find_command (CmdList *clist, int omax, char *com, int *cnt)
{
  int j, min=0, max, pos, len, old_pos = -1;
 
  len = com?strlen(com):0;
  max = omax;

  while (1) {
    pos = (max + min) / 2;
    if (pos == old_pos) {
      *cnt = 0;
      return ((CmdList *) 0);
    }
    old_pos = pos;
    j = strncasecmp(com, clist[pos].command, len);
    if (j == 0) break;
    else if (j < 0) max = pos-1;
    else min = pos+1;
  }
  *cnt = 1;
  min = pos - 1;
  while ((min >= 0) && (strncasecmp(com, clist[min].command, len) == 0)) {
    (*cnt)++;
    min--;
  }
  min++;
  max = pos + 1;
  while ((max < omax) && (strncasecmp(com, clist[max].command, len) == 0)) {
    (*cnt)++;
    max++;
  }
  if (strlen(clist[min].command) == len)
     *cnt *= -1;
  return (&(clist[min]));
}
 
/* ------------------------------------------------------------------ */
 
int lookup_command(command_ptr command_list, char *string, int *indx)
{
  int ret = c_none;
  int loop;
 
  *indx = 0;
  for (loop=0; command_list[loop].command; loop++) {
    if (strcasecmp(string, command_list[loop].command) == 0) {
      *indx = (int)command_list[loop].constant;
      return loop;
    }
    if (strncasecmp(string, command_list[loop].command, strlen(string)) == 0)
    {
      if (ret == c_none) {
        *indx = (int)command_list[loop].constant;
        ret = loop;
      } else {
        ret = c_amb;
        *indx = 0;
      }
    }
  }
  return ret;
}
 
/* ------------------------------------------------------------------ */
static char *next_expr(char **str, char tt)
{
  char *temp, *ptr2, *ptr3, *ptr;
  if (!*str) return NULL;
  ptr = *str;
  if (!*ptr) return NULL;
  if (*ptr != tt) {
    say("Expression syntax");
    return NULL;
  }
  temp = matching_end(ptr+1, tt, (tt=='(')?')':'}');
  if (!temp) {
    say("Unmatched %c", tt);
    return NULL;
  }
  for (ptr++; *ptr == ' '; ptr++);
  for (ptr2 = temp + 1; *ptr2 == ' '; ptr2++);
  for (ptr3 = temp - 1; *ptr3 == ' '; ptr3--);
  ptr3[1] = 0;
  *str = ptr2;
  return ptr;
}

/* ------------------------------------------------------------------ */
static void usr_crash(char *str)
{
  say("Dividing: %d", 5/atoi(str));
}

/* ------------------------------------------------------------------ */
extern int assign_matches(char *str, char *ret, int let);
static void user_foreach(char *str, char *varpar, char *subargs)
{
  char ass[MAXLEN], exec[MAXLEN], *rest, ret[MAXLEN*5], *var;
  char one[MAXLEN], *line, *sline;
  int dummy, disp;

  sline = line = m_strcpy(str);
  grab_word(&line, ' ', ass);
  strcat(ass, ".");
  assign_matches(ass, ret, sizeof(ret));
  var = m_grab_word(&line, ' ');
  
  while (*line==' ') line++;
  if (!(rest = next_expr(&line, '{')))
     say("*** Missing commands in FOREACH");
  else {
    line = ret;
    while (grab_word(&line, ' ', one)) {
      sprintf(exec, "%s %s", var, one);
      disp = getivar("DISPLAY");
      setivar("DISPLAY", -1);
      user_assign(exec, TRUE);
      setivar("DISPLAY", disp);
      parse_line(rest, subargs, FALSE, FALSE);
    }
  }
  myfree(var);
  myfree(sline);
}

/* ------------------------------------------------------------------ */
static char *expand_target(char *target)
{
  if (strcasecmp(target, "*") == 0) return get_channel(NULL);
  return NULL;
}

/* ------------------------------------------------------------------ */
extern int sys$setddir();

static void user_cd(char *string)
{
  char device[MAXLEN], newdir[MAXLEN], olddir[MAXLEN];
  struct dsc$descriptor_s old_d, new_d;
  unsigned short maxlen;
  int num, status;

  old_d.dsc$w_length = new_d.dsc$w_length = MAXLEN;
  old_d.dsc$b_dtype = new_d.dsc$b_dtype = DSC$K_DTYPE_T;
  old_d.dsc$b_class = new_d.dsc$b_class = DSC$K_CLASS_S;
  old_d.dsc$a_pointer = olddir;
  new_d.dsc$a_pointer = newdir;
  num = grab_word(&string, ':', device);
  if (num>0) {
  } else string = device;
  strcpy(newdir, string);
  new_d.dsc$w_length = strlen(string);
  status = sys$setddir(&new_d, &maxlen, &old_d);
  olddir[maxlen] = 0;
  if (status&1) {
    status = sys$setddir(0, &maxlen, &old_d);
    olddir[maxlen] = 0;
  }
  say("*** Current directory is now: %s", olddir);
}

/* ------------------------------------------------------------------ */
static void user_while(char *string, int param, char *args)
{
  int added = 0, done = FALSE;
  char *end = NULL, *condition, *ret, *line, *cond, *m_end;

  line = condition = m_strcpy(string);
  if (!(cond = next_expr(&line, '(')))
     say("*** Missing condition in WHILE");
  else if (!(end = next_expr(&line, '{')))
     say("*** Missing command in WHILE");
  else {
    done = FALSE;
    m_end = m_strcpy(end);
    while (!done)
    {
      ret = parse_inline(cond, args, &added);
      if (ret && *ret && (*ret!='0'))
      {
        parse_line(m_end, args, FALSE, FALSE);
        strcpy(m_end, end);
      } else done = TRUE;
      if (ret) myfree(ret);
    }
    myfree(m_end);
  }
  myfree(condition);
}

/* ------------------------------------------------------------------ */
static void user_lastlog(char *string)
{
  char word[MAXLEN], match[MAXLEN], re_match[MAXLEN], *end;
  int flags = 0, num = 0, comm, dummy, oldlevel, max_d = 0, inv = 0;
  win_ptr oldwin;
  list_ptr walk = NULL;

  *match = 0;
  while (*string=='-') {
    string++;
    (void)grab_word(&string, ' ', word);
    if (!lookup_level(word, &flags, &inv)) {
      if (strncasecmp(word, "NUM", strlen(word)) == 0)
      {
        grab_word(&string, ' ', word);
        num = atoi(word);
      }
      else if (strncasecmp(word, "MAX_DEPTH", strlen(word)) == 0)
      {
        grab_word(&string, ' ', word);
        max_d = atoi(word);
      }
      else if (strncasecmp(word, "PATTERN", strlen(word)) == 0)
      {
        char temp[MAXLEN], *w = temp;
        while (isspace(*string)) string++;
        if (*string == '\"') {
          w++;
          grab_word(&string, '\"',  match);
        } else grab_word(&string, ' ', match);
      } else {
        say("*** Flag \"%s\" unknown or ambiguous.", word);
        return;
      }
    }
  }
  end = string;
  while (isspace(*end)) end++;
  if (*end) {
    if (atoi(end) != 0) num = atoi(end);
    else strcpy(match, string);
  }
  if (!flags) flags = ALL;
  if (!strchr(match, '*') && !strchr(match, '%') && !strchr(match, '?'))
    sprintf(re_match, "*%s*", match);
  else
    strcpy(re_match, match);
  oldwin = set_outwin(gwin);
  oldlevel = set_loglevel(LASTLOG);
  say("*** Lastlog [%s] num: %d max_depth: %d:", re_match, num, max_d);
  if (max_d == 0)
    walk = gwin->lastlog.oldest;
  else {
    int count = 1;
    walk = gwin->lastlog.newest;
    while (walk && (count++ < max_d) && walk->older) walk = walk->older;
  }
  if (num != 0) {
    list_ptr w = gwin->lastlog.newest;
    int count = 0;
    while (w && (count<num) && (w!=walk))
    {
      if ((w->type & flags) && (wild_match(re_match, w->text) >= 0))
        count++;
      if (count<num) w = w->older;
    }
    walk = w;
  }
  while (walk)
  {
    if ((walk->type & flags) && (wild_match(re_match, walk->text) >= 0))
      say("%s", walk->text);
    walk = walk->newer;
  }
  say("*** End of lastlog");
  set_outwin(oldwin);
  set_loglevel(oldlevel);
}

/* ------------------------------------------------------------------ */
static void user_assign2(char *string, int param, char *args)
{
  int added = 1, old;
  char *res;

  old = getivar("DISPLAY");
  setivar("DISPLAY", -1);
  res = parse_inline(string, args, &added);
  myfree(res);
  if (getivar("DISPLAY") == -1) setivar("DISPLAY", old);
}
/* ------------------------------------------------------------------ */
static void user_if(char *string, int param, char *args)
{
  int old, added = 1;
  char *walk, *ans, *res;
  char *saved, *line, *cond;

  line = saved = m_strcpy(string);
  if (!(cond = next_expr(&line, '(')))
    say("*** Missing condition in IF");
  else if (!(walk = next_expr(&line, '{')))
    say("*** THEN condition missing from IF");
  else {
    res = parse_inline(cond, args, &added);
    if (getivar("DEBUG") & DEBUG$USER_IF)
      yell("If expression expands to: (%s)", res?res:"null");
    if (!res || (*res==0) || (*res=='0'))
      walk = next_expr(&line, '{');
    if (walk) parse_line(walk, args, FALSE, FALSE);
  }
  myfree(saved);
}
/* ------------------------------------------------------------------ */
static void user_cmt(char *string)
{
}
/* ------------------------------------------------------------------ */
static void user_ping(char *string)
{
  (void)new_send(gsrv, "PRIVMSG %s :\001PING %d\001\n", string, time(NULL));
}
/* ------------------------------------------------------------------ */
static struct command_node names_flags[] = {
  {{"ALL"},     (char *)0},
  {{"MAX"},     (char *)1},
  {{"MIN"},     (char *)2},
  {{"PRIVATE"}, (char *)3},
  {{"PUBLIC"},  (char *)4},
  {{NULL},     (char *)NULL}
};
 
static void user_names(char *string, int comm)
{
  int dummy, num;
  char word[80], msg[80], *target;
  struct list_structs *ptr;

  num = grab_word(&string, ' ', word);
  if (comm) ptr = &list_rpl;
  else ptr = &names_rpl;
  do {
    if (word[0] == '-') {
      num = lookup_command(names_flags, &word[1], &dummy);
      if (num < 0) {
        say("*** Invalid flag: %s", word);
        return;
      }
      if (dummy == 0) {
        ptr->public = ptr->private = TRUE;
      }
      else if (dummy == 1) {
        (void)grab_word(&string, ' ', word);
        ptr->max = atoi(word);
      }
      else if (dummy == 2) {
        (void)grab_word(&string, ' ', word);
        ptr->min = atoi(word);
      }
      else if (dummy == 3) {
        ptr->public = FALSE;
        ptr->private = TRUE;
      }
      else if (dummy == 4) {
        ptr->public = TRUE;
        ptr->private = FALSE;
      }
      num = grab_word(&string, ' ', word);
    }
  } while (word[0] == '-');
  target = expand_target(word);
  if (!target && strstr(word, "*")) {
    if (ptr->str) {
      say("*** There is already a %s active. Please wait.",
          comm?"list":"names");
      return;
    } else ptr->str = m_strcpy(word);
    *word = 0;
  }
  new_send(gsrv, "%s %s\n", comm?"LIST":"NAMES", target?target:word);
}
 
/* ------------------------------------------------------------------ */
static void user_expand(char *string, int flag)
{
  char new[MAXLEN*10];
  int added;
  while (*string == ' ') string++;
  if (flag)
    parse_line(string, "", FALSE, FALSE);
  else {
    expand_alias(string, "", &added, new, sizeof(new));
    say("old [%s] new [%s]", string, new);
  }
}
/* ------------------------------------------------------------------ */
static void user_invite(char *string)
{
  char chan[MAXLEN], user[MAXLEN];
 
  (void)grab_word(&string, ' ', user);
  while (*string == ' ') string++;
  if (*string==0) (void)get_channel(chan);
  else (void)strcpy(chan, string);
  (void)new_send(gsrv, "INVITE %s :%s\n", user, chan);
}
/* ------------------------------------------------------------------ */
static void user_desc(char *string)
{
  char s[MAXLEN];

  (void)grab_word(&string, ' ', s);
  say("* -> %s: %s %s", s, gsrv->nick?gsrv->nick:"(null)", string);
  (void)new_send(gsrv, "PRIVMSG %s :\001ACTION %s\001\n", s, string);
}
/* ------------------------------------------------------------------ */
static void user_kick(char *string)
{
  char chan[MAXLEN], user[MAXLEN];
 
  (void)grab_word(&string, ' ', chan);
  while (*string == ' ') string++;
  if (*string==0) {
    (void)strcpy(user,chan);
    (void)get_channel(chan);
    (void)new_send(gsrv, "KICK %s %s\n",chan,user);
  } else {
    (void)grab_word(&string, ' ', user);
    while (*string == ' ') string++;
    if (*string==0)
      (void)new_send(gsrv, "KICK %s %s\n",chan,user);
    else
      (void)new_send(gsrv, "KICK %s %s :%s\n",chan,user,string);
  }
}
/* ------------------------------------------------------------------ */
static void send_chan(char *string)
{
  char ack[MAXLEN];
  int oldlevel;
  win_ptr oldwin;

  oldwin = set_outwin(gwin);
  oldlevel = set_loglevel(PUBLIC);
  if (get_channel(ack)) {
    (void)new_send(gsrv, "PRIVMSG %s :%s\n", ack, string);
    say("> %s ", string);
  }
  else say("*** You aren't on a channel!");
  set_outwin(oldwin);
  set_loglevel(oldlevel);
}
/* ------------------------------------------------------------------ */
#define IS_DCC_CHAT(x) (*x=='=')
extern short dcc_send_chat_msg(char *, char *);
/* ------------------------------------------------------------------ */
void send_msg(outuser, string)
  char *outuser;
  char *string;
{
  int ret_send, oldlevel, print = TRUE, chan;
  char msg[MAXLEN], on_line[MAXLEN], format[MAXLEN];
  win_ptr win, ind, ret, oldwin;

  win = isquery(gsrv, outuser);
  if (win) oldwin = set_outwin(win);
  if (is_chan(outuser)) {
    oldlevel = set_loglevel(PUBLIC);
    (void)new_send(gsrv, "PRIVMSG %s :%s\n", outuser, string);
    if (get_chan_num(gsrv->chan_list, outuser, &ind) && ind) {
      (void)sprintf(on_line, "%s %s", outuser, string);
      if (!win) oldwin = set_outwin(win);
      if (handle_on(o_send_public, on_line, 0)) print = FALSE;
      strcpy(format, "%0.0s> %s");
    } else  {
      if (!win) {
        win = type_winget(gsrv, PUBLIC);
        oldwin = set_outwin(win);
      }
      strcpy(format, ">%s> %s");
    }
  } else if (IS_DCC_CHAT(outuser)) {
    if (!win) {
      win = type_winget(gsrv, DCC);
      oldwin = set_outwin(win);
    }
    oldlevel = set_loglevel(DCC);
    if (dcc_send_chat_msg(&outuser[1], string) != -1)
    {
      (void)sprintf(on_line, "%s %s", outuser, string);
      if (handle_on(o_send_msg, on_line, 0)) print = FALSE;
      outuser++;
      strcpy(format, "=> =%s= %s");
    }
    else {
      say("*** There is no such active dcc connection.");
      print = FALSE;
    }
  } else {
    myfree(g_sent); myfree(g_body);
    g_sent = m_strcpy(outuser);
    g_body = m_strcpy(string);
    if (!win) {
      win = type_winget(gsrv, MSGS);
      oldwin = set_outwin(win);
    }
    oldlevel = set_loglevel(MSGS);
    strcpy(format, "-> *%s* %s");
    sprintf(on_line, "%s %s", outuser, string);
    if (handle_on(o_send_msg, on_line, 0)) print = FALSE;
    else new_send(gsrv, "PRIVMSG %s :%s\n", outuser, string);
  }
  if (print) say(format, outuser, string);
  set_loglevel(oldlevel);
  set_outwin(oldwin);
}
/* ------------------------------------------------------------------ */
extern void kill_hold();
/* ------------------------------------------------------------------ */
static void user_flush(char *string)
{
  old_display = getivar("DISPLAY");
  flushing = TRUE;
  myfree(flush_nick);
  flush_nick = m_strcpy(gsrv->nick);
  (void)new_send(gsrv, "USERHOST %s\n", gsrv->nick);
  setivar("DISPLAY", 0);
  kill_hold();
}
/* ------------------------------------------------------------------ */
int *userhost_queue = NULL;
/* ------------------------------------------------------------------ */
static void user_userhost(char *string)
{
  int loop;
  char nick[MAXLEN], cmd[MAXLEN];
  if (!userhost_queue) userhost_queue = make_new_stack(FALSE, 0);
  (void)grab_word(&string, ' ', nick);
  (void)grab_word(&string, ' ', cmd);
  if (strcasecmp(cmd, "-cmd")==0)
    push_element(userhost_queue, nick, string, 0, TRUE);
  else
    push_element(userhost_queue, nick, NULL, 0, TRUE);
  new_send(gsrv, "USERHOST %s\n", nick);
}
/* ------------------------------------------------------------------ */
static void user_clear(char *string)
{
  clear_window();
}
extern void exec_msg(char *, char *); 
/* ------------------------------------------------------------------ */
static void user_msg(char *string)
{
  char loca[MAXLEN];
 
  (void)grab_word(&string, ' ', loca);
  if (strcmp(loca, ",") == 0)
    if (g_from) strcpy(loca, g_from);
    else *loca = 0;
  else if (strcmp(loca, ".") == 0)
    if (g_sent) strcpy(loca, g_sent);
    else *loca = 0;
  else if (*loca == '%')
  {
    exec_msg(&loca[1], string);
    return;
  }
  send_msg(loca, string);
}
/* ------------------------------------------------------------------ */
static void user_query(char *string)
{
  char mess[MAXLEN];
  char user[MAXLEN];
  win_ptr oldwin;

  (void)grab_word(&string, ' ', user);
  if (strlen(user) == 0) {
    if (clearquery(user))
      (void)sprintf(mess, "You stop querying %s.", user);
    else
      (void)sprintf(mess, "You weren't querying anyone.");
  } else {
    setquery(user);
    (void)sprintf(mess, "You are now querying %s.", user);
  }
  oldwin = set_outwin(gwin);
  say("%s", mess);
  set_outwin(oldwin);
}
/* ------------------------------------------------------------------ */
static void user_join(char *string)
{
  int indx;
  char chan[MAXLEN], *on_chan;
  win_ptr win;
  (void)grab_word(&string, ' ', chan);
  if (*chan=='-')
  {
    if (strncasecmp("-INVITE", chan, (strlen(chan)>7)?7:strlen(chan))==0)
      if (g_invite) strcpy(chan, g_invite);
      else *chan = 0;
  }
  if (gsrv) indx = get_chan_num(gsrv->chan_list, chan, &win);
  else indx = 0;
  if (indx) set_channel(indx);
  else {
    if (getivar("NOVICE"))
      new_send(gsrv, "JOIN 0\n");
    new_send(gsrv, "JOIN %s %s\n", chan, string);
  }
/* These 2 lines are needed in case they join a channel that they are
   already on .. the server returns no notice */
  find_input_prompt(FALSE);
  updatestatwin();
}
/* ------------------------------------------------------------------ */
static void user_away(char *string)
{
  if (strlen(string) == 0)  gsrv->away = FALSE;
  else                      gsrv->away = TRUE;
  (void)new_send(gsrv, "AWAY :%s\n", string);
}
 
/* ------------------------------------------------------------------ */
static void user_topic(char *string)
{
  char chan[TOLEN], *targ;
 
  (void)grab_word(&string, ' ', chan);
  targ = expand_target(*chan?chan:"*");
  if (*string) (void)new_send(gsrv, "TOPIC %s :%s\n", targ?targ:chan, string);
  else (void)new_send(gsrv, "TOPIC %s\n", targ?targ:chan);
}
 
/* ------------------------------------------------------------------ */
static void user_notice(char *string)
{
  char target[MAXLEN];
  win_ptr win, oldwin;

  (void)grab_word(&string, ' ', target);
  (void)get_chan_num(gsrv->chan_list, target, &win);
  if (win==NW) win = type_winget(gsrv, CRAP);
  oldwin = set_outwin(win);
  say("-> -%s- %s", target, string);
  set_outwin(oldwin);
  (void)new_send(gsrv, "NOTICE %s :%s\n", target, string);
}

/* ------------------------------------------------------------------ */
static void user_input(char *str)
{
  char prompt[MAXLEN], input[MAXLEN];
  while (*str==' ') str++;
  grab_word(&str, (*str=='"')?'"':' ', prompt);
  while (*str==' ') str++;
  read_input(input, sizeof(input)-1, prompt);
  parse_line(str, input, TRUE, FALSE);
}

/* ------------------------------------------------------------------ */
static void user_oper(char *str)
{
  int old;
  char user[MAXLEN], pass[MAXLEN];
  grab_word(&str, ' ', user);
  grab_word(&str, ' ', pass);
  if (*pass == 0)
  {
    old = set_echo(FALSE);
    read_input(pass, sizeof(pass)-1, "Password: ");
    set_echo(old);
  }
  new_send(gsrv, "OPER %s %s\n", user, pass);
}

/* ------------------------------------------------------------------ */
static char basicarray[30][20] = {
  {"WHO "},
  {"PART "},
  {"WHOIS "},
  {"LIST "},                                       
  {"NOTICE "},
  {"MODE "},
  {"MOTD "},
  {""},     /* intentionally left blank for QUOTE */
  {"ADMIN "},
  {"LUSERS "},
  {"TIME "},    /* 10 */
  {"INFO "},
  {"OPER "},
  {"CONNECT "},
  {"TRACE "},
  {"DIE "},
  {"REHASH "},
  {"RESTART "},
  {"LINKS "},
  {"STATS "},
  {"SUMMON "},   /* 20 */
  {"WALLOPS "},
  {"WHOWAS "},
  {"NAMES "},
  {"NICK "},
};

static void usr_bsc(char *string, int comm)
{
  char target[MAXLEN], *targ;
  if (comm<0) {
    comm = -comm;
    (void)grab_word(&string, ' ', target);
    targ = expand_target(target);
    (void)new_send(gsrv, "%s%s %s\n", basicarray[comm-1], targ?targ:target,
                   string);
    if (comm==4) (void)handle_on(o_send_notice, string, 0);
  } else {
    (void)new_send(gsrv, "%s%s\n", basicarray[comm], string);
    if (comm==4) (void)handle_on(o_send_notice, string, 0);
  }
}
 
/* ------------------------------------------------------------------ */
static void usr_bsc2(char *string, int comm)
{
  char first[MAXLEN];
 
  (void)grab_word(&string, ' ', first);
  (void)new_send(gsrv, "%s %s :%s\n", basicarray[comm], first, string);
}
/* ------------------------------------------------------------------ */
static void usr_bsc3(char *string, int comm)
{
  (void)new_send(gsrv, "%s :%s\n", basicarray[comm], string);
}
/* ------------------------------------------------------------------ */
void user_quit(char *string)
{
  extern void exec_close_all();
  new_send(gsrv, "QUIT :%s\n", *string?string:"Leaving");
  quit = TRUE;
  delete_windows();
  (void)cleanup();
  exec_close_all();
  (void)sys$exit(1);
}
/* ------------------------------------------------------------------ */
static void user_me(char *string)
{
  char msg[MAXLEN], to[MAXLEN], *tmp;
  char loca[MAXLEN], on_line[MAXLEN];
  win_ptr oldwin, win;
  int oldlevel;
  if (!(tmp = getquery())) {
    if (!get_channel(to)) {
      say("*** No target specified.");
      return;
    }
  } else strcpy(to, tmp);
  (void)new_send(gsrv, "PRIVMSG %s :\001ACTION %s\001\n", to, string);
  (void)sprintf(on_line, "%s %s", gsrv->nick, string);
  win = gwin;
/*  win = type_winget(gsrv, ACTIONS); */
  oldwin = set_outwin(win);
  oldlevel = set_loglevel(ACTIONS);
  if (!handle_on(o_send_action, on_line, 0))
    say("*> %s %s", gsrv->nick, string);
  set_outwin(oldwin);
  set_loglevel(oldlevel);
}
 
/* ------------------------------------------------------------------ */
char *win_newserver(char *str, server_ptr serv);
extern void connect_server_by_number(int);
extern void print_server_list();
void user_server(char *string)
{
  if (!*string)
    print_server_list();
  else  {
    int did = 0, num = 0;
    char *w;
    for (w= string; (*w >= '0') && (*w <= '9'); w++) {
      num = num * 10 + *w - '0';
      did = 1;
    }
    if (did && ((*w == ' ') || (*w == 0))) {
      connect_server_by_number(num);
      return;
    }
    /* Replace ' ' with ':' for partial compatibility with unix ircII */
    for (w = string; *w; w++) if (*w==' ') *w = ':';
    string = win_newserver(string, gsrv);
  }
}
/* ------------------------------------------------------------------ */
static void user_deop(char *string)
{
  (void)new_send(gsrv, "MODE %s -o\n", gsrv->nick);
}
/* ------------------------------------------------------------------ */
static void user_squit(char *string)
{
  char srver[MAXLEN];
 
  (void)grab_word(&string, ' ', srver);
  while (*string == ' ') string++;
  if (*string) {
    (void)new_send(gsrv, "SQUIT %s :%s\n",srver,string);
  } else {
    say("Server Quit comments required for /squit.");
  }
}
/* ------------------------------------------------------------------ */
static void user_echo(char *string)
{
  yell("%s", string?string:"(null)");
}
/* ------------------------------------------------------------------ */
static void user_kill(char *string)
{
  char user[MAXLEN];
 
  (void)grab_word(&string, ' ', user);
  while (*string == ' ') string++;
  if (*string)
    (void)new_send(gsrv, "KILL %s :%s\n",user, string);
  else
    say("Kill comments required for /kill.");
}
/* ------------------------------------------------------------------ */
static void user_ctcp(char *string)
{
  char to[MAXLEN], *s, *targ;
 
  (void)grab_word(&string, ' ', to);
  targ = expand_target(to);
  while (*string==32) string++;
  if (to[0] == 0)
    say("*** Request from whom?");
  else if (string[0] == 0) {
    new_send(gsrv, "PRIVMSG %s :\001VERSION\001\n", targ?targ:to);
  } else {
    for (s = string; *s && (*s != ' '); s++) *s = toupper(*s);
    if ((strncmp(string, "PING", 4) == 0) && !*s)
      new_send(gsrv, "PRIVMSG %s :\001%PING %d\001\n", targ?targ:to,
               time(NULL));
    else 
      new_send(gsrv, "PRIVMSG %s :\001%s\001\n", targ?targ:to, string);
  }
}
/* ------------------------------------------------------------------ */
static void admin_disabled(char *word, int param)
{
  char comm[20];
  strcpy(comm, "<unknown>");
  if (param==0)
    strcpy(comm, "ON");
  else if (param==1)
    strcpy(comm, "EXEC");
  else if (param==2)
    strcpy(comm, "SPAWN");
  else if (param==3)
    strcpy(comm, "SERVER");
  yell("*** The %s command has been disabled by your admin.", comm);
}
/* ------------------------------------------------------------------ */
static void user_version(char *str)
{
  if (!*str)
  {
    say("Client version: \002%s\002", VERSION);
    say("Thanks to the following people:");
    say("masdough   masdough@ubvms.cc.buffalo.edu (Author)");
    say("toofache   iscnwl@mars.cc.nus.sg");
    say("bighorn    ARSEBESTYEN@CSUPomona.Edu");
    say("remainz    chedean@acs.eku.edu");
    say("quasar     stdrjn@niord.shsu.edu");
    say("melvin     MELVIN@ntutl1.ntu.ac.sg");
    say("tboard     uros     squiz     fordy");
    say("tychy      matt");
  }
  new_send(gsrv, "VERSION %s\n", str); 
}
/* ------------------------------------------------------------------ */
int waiting = FALSE;
#ifndef __GNUC__
extern int sleep();
#endif
extern void process_wait(server_ptr);
extern int lib$ast_in_prog(void);

static void user_wait(char *word)
{
  int loop = 0, old = 7;
  waiting = TRUE;
  new_send(gsrv, "WAIT\n");
  if (!lib$ast_in_prog()) {
    while (waiting && old--) {
      sleep(waiting); 
    }
  }
  else process_wait(gsrv);
}

/* ------------------------------------------------------------------ */
static void user_redirect(char *str)
{
  char *whom;
  whom = next_arg(&str);
  set_redirect(whom, gsrv);
  parse_line(str, NULL, FALSE, TRUE);
  new_send(gsrv, "REDIRECT\n"); 
}
/* ------------------------------------------------------------------ */
static void user_notify(char *str)
{
  notify(gsrv, str);
}
/* ------------------------------------------------------------------ */
static void user_show_chan(char *str)
{
}
/* ------------------------------------------------------------------ */
static void user_xecho(char *str)
{
  win_ptr win = NW, oldwin;
  int level = CRAP, oldlevel, dummy=0;
  char *word;
  while (*str=='-') {
    word = next_arg(&str);
    word++;
    if (strcasecmp(word, "level") == 0) {
      word = next_arg(&str);
      level = dummy = 0;
      lookup_level(word, &level, &dummy);
    }
    else if (strcasecmp(word, "window") == 0) {
      word = next_arg(&str);
      win = get_win_by_name(word);
    } else {
      say("*** Unknown flag: %s", word);
      return;
    }
  }
  if (win==NW) win = type_winget(gsrv, level);
  if (win != NW) oldwin = set_outwin(win);
  oldlevel = set_loglevel(level);
  yell("%s", str);
  set_loglevel(oldlevel);
  if (win != NW) set_outwin(oldwin);
}
/* ------------------------------------------------------------------ */
static void user_dump(char *str, int comm)
{
  switch(comm) {
    case 0: if (gsrv) raw_dump_channel(gsrv->chan_list);
      break;
    default:
      say("Unknown dump paramater");
      break;
  }
}
/* ------------------------------------------------------------------ */
static CmdList command_list[] =
{
  { "",          send_chan,      0 },
  { "#",         user_cmt,       0 },
  { ":",         user_cmt,       0 },
  { "@",         user_assign2,   0 },
  { "aaa",       master_list,    0 },
  { "admin",     usr_bsc,        8 },
  { "alias",     user_alias,     0 },
  { "assign",    user_assign,    1 },
  { "away",      user_away,      0 },
  { "bind",      dobind,         0 },
  { "bye",       user_quit,      0 },
  { "cd",        user_cd,        0 },
  { "channel",   user_join,      0 },
  { "clear",     user_clear,     0 },
  { "comment",   user_cmt,       0 },
  { "connect",   usr_bsc,       13 },
  { "crash",     usr_crash,      0 },
  { "ctcp",      user_ctcp,      0 },
  { "d_channel", user_dump,      0 },
  { "date",      usr_bsc,       10 },
  { "dcc",       user_dcc,       0 },
  { "deop",      user_deop,      0 },
  { "describe",  user_desc,      1 },
  { "die",       usr_bsc,       15 },
  { "echo",      user_echo,      0 },
  { "eval",      user_expand,    1 },
#ifdef ENABLE_EXEC
  { "exec",      user_exec,      0 },
#else
  { "exec",      admin_disabled, 1 },
#endif
  { "exit",      user_quit,      0 },
  { "expand",    user_expand,    0 },
  { "flush",     user_flush,     0 },
  { "foreach",   user_foreach,   0 },
  { "help",      help,           0 },
  { "if",        user_if,        0 },
  { "ignore",    user_ignore,    0 },
  { "info",      usr_bsc,       11 },
  { "input",     user_input,     0 },
  { "invite",    user_invite,    0 },
  { "join",      user_join,      0 },
  { "kick",      user_kick,      0 },
  { "kill",      user_kill,      0 },
  { "lastlog",   user_lastlog,   0 },
  { "leave",     usr_bsc,       -2 },
  { "links",     usr_bsc,       18 },
  { "list",      user_names,     1 },
  { "load",      load_file,      0 },
  { "lusers",    usr_bsc,        9 },
  { "me",        user_me,        0 },
  { "mode",      usr_bsc,       -6 },
  { "motd",      usr_bsc,        6 },
  { "msg",       user_msg,       0 },
  { "names",     user_names,     0 },
  { "nick",      usr_bsc,       24 },
  { "notice",    user_notice,    0 },
  { "notify",    user_notify,    0 },
#ifdef ENABLE_ON
  { "on",        on,             0 },
#else
  { "on",        admin_disabled, 0 },
#endif
  { "oper",      user_oper,      0 },
  { "part",      usr_bsc,       -2 },
  { "ping",      user_ping,      0 },
  { "query",     user_query,     0 },
  { "quit",      user_quit,      0 },
  { "quote",     usr_bsc,        7 },
  { "redirect",  user_redirect,  0 },
  { "rehash",    usr_bsc,       16 },
  { "remap",     remap,          0 },
  { "restart",   usr_bsc,       17 },
  { "say",       send_chan,      0 },
  { "server",    user_server,    0 },
  { "set",       user_set,       0 },
  { "show_chan", user_show_chan, 0 },
#ifdef ENABLE_SPAWN
  { "spawn",     user_spawn,     0 },
#else
  { "spawn",     admin_disabled, 2 },
#endif
  { "squit",     user_squit,     0 },
  { "stats",     usr_bsc,       19 },
  { "summon",    usr_bsc,       20 },
  { "time",      usr_bsc,       10 },
  { "topic",     user_topic,     0 },
  { "trace",     usr_bsc,       14 },
  { "type",      bind_typetext,  0 },
  { "userhost",  user_userhost,  0 },
  { "version",   user_version,   0 },
  { "wait",      user_wait,      0 },
  { "wallop",    usr_bsc3,      21 },
  { "while",     user_while,     0 },
  { "who",       usr_bsc,       -1 },
  { "whois",     usr_bsc,        2 },
  { "whowas",    usr_bsc,       22 },
  { "window",    user_window,    0 },
  { "xecho",     user_xecho,     0 },
};
/* ------------------------------------------------------------------ */
#define NUMBER_OF_COMMANDS (sizeof(command_list) / sizeof(CmdList)) - 1
/* ------------------------------------------------------------------ */
extern int load_depth;
static int p_d = 0;

void parse_line(char *str, char *args, int append_flag, int interactive)
{
  int added = 0, old;
  char line[MAXLEN*10], *nwalk, *walk, *add;

  p_d++;
  if (getivar("DEBUG")&2048) yell("[%d] Parse_line enter: [%s]", p_d, str);
  walk = str;
  if (args) {
    do {
      nwalk = expand_alias(walk, args, &added, line, sizeof(line));
      if (getivar("DEBUG") & 4096)
        yell("[%d] Parse_line [%s] -to- [%s][%s] (%s)", p_d, walk,
             line, nwalk?nwalk:"null", args?args:"null");
      walk = nwalk;
      if (getivar("DEBUG") & 4096)
        yell("walk: %sempty line %sempty append_flag %d added %d args %sempty",
             (walk&&!*walk)?"non":"", *line?"":"non", append_flag,
             added, *args?"non":"");
      if ((!walk || !*walk) && *line && append_flag && !added && *args)
      {
        strcat(line, " ");
        strcat(line, args);
      }
      if (*line) handle_command_line(line, interactive, args);
    } while (walk && *walk);
  } else
    if (load_depth) {
      handle_command_line(str, interactive, args);
    } else
      while (*walk)  {
        grab_word(&walk, '\n', line);
        handle_command_line(line, interactive, args);
      }
  if (getivar("DEBUG") & 2048) yell("[%d] parse line ended!", p_d);
  p_d--;
}

/* ------------------------------------------------------------------
 * expand_alias:
 */

#define BRACE_L '{'
#define BRACE_R '}'
#define PAREN_L '('
#define PAREN_R ')'

static int e_l = 0;
char *expand_alias(char *string, char *args, int *added, char *ret, int len)
{
  char line[MAXLEN*10], quote_str[MAXLEN], other, *saved, *new, *ptr;
  char *free_it, *walk;
  int done = 0, quote_len = 0, ch, old;

  old = sys$setast(0);
  walk = line;
  *walk = 0;
  ptr = free_it = m_strcpy(string);
  if (*ptr == '@') *added = TRUE;
  while (ptr && *ptr && !done) {
    switch (*ptr)
    {
    case '$':
      if (*free_it == '@')
      {
        *walk++ = *ptr++;
        break;
      }
      *ptr++ = 0;
      while (*ptr == '^') {
        ptr++;
        quote_str[quote_len++] = *ptr++;
      }
      if (getivar("DEBUG") & 4096) {
        *walk = 0;
        yell("ret: [%s] before: [%s] args: [%s]", line, ptr?ptr:"null",
             args?args:"{NULL}");
        yell("Length left: [%d]", sizeof(line) - (int)walk + (int)line);
      }
      ptr = alias_special(ptr, args, added, walk,
                          sizeof(line) - (int)walk + (int)line);
      walk += strlen(walk);
      if (getivar("DEBUG")&4096)
        yell("ret: [%s] after: [%s]", line, ptr?ptr:"null");
      break;
    case ';':
      done = TRUE;
      ptr++;
      break;
    case PAREN_L:
    case BRACE_L:
      *added = TRUE;
      *walk++ = ch = *ptr;
      other = (*ptr==BRACE_L)?BRACE_R:PAREN_R;
      if (!(new = strip_ends(ptr, *ptr, other, walk,
                             sizeof(line) - (int)walk + (int)line)))
      {
        ptr++;
        if (getivar("DEBUG")&1024) yell("*** Unmatched %c", ch);
      } else {
        walk += strlen(walk);
        *walk++ = other;
        ptr = new;
      }
      break;
    case '\\':
      ptr++;
      if (*ptr) *walk++ = *ptr++;
      break;
    default:
      *walk++ = *ptr++;
      break;
    }
  }
  myfree(free_it);
  *walk = 0;
  if (getivar("DEBUG") & DEBUG$EXPAND)
    yell("[%d] Expanded [%s] to [%s]", p_d, string?string:"null", line);
  strcpy(ret, line);
  if (old==SS$_WASSET) sys$setast(1);
  if (!ptr) return NULL;
  return (char *)((int)string + (int) ptr - (int)free_it);
}

static int exe_level = 0;
/* ======================================================================= */
void handle_command_line(char *string, int interactive, char *param)
{
  CmdList *command;
  char word[MAXLEN], *outuser, *tmp;
  int cmd_cnt, expand = 1, olddisplay, did = FALSE;

  if (getivar("DEBUG") & DEBUG$EXECUTE)
    yell("Execute: [%d] \026%s\026", exe_level, string);
  olddisplay = getivar("DISPLAY");
  if (!string || (!*string)) return;
  if ((*string == '/') || !interactive || getbvar("COMMAND_MODE"))
  {
    if (*string == '/') string++;
    if (*string == '/') {string++;expand=0;}  /* Two backslashes in a row */
    if (*string == '^') {
      string++;
      setivar("DISPLAY", -1);
    }
    if (*string=='#') return;

    if (*string == '@') {
      word[0] = *string++;
      word[1] = 0;
    } else if ((*string == ' ') && (interactive)) {
      string++;
      word[0] = 0;
    } else (void)clean_word(&string, word);
    if (expand) {
      exe_level++;
      did = exec_alias(word, string, param);
      exe_level--;
      if (did) {
        if (getivar("DISPLAY")==-1) setivar("DISPLAY", olddisplay);
        if (getivar("DEBUG") & DEBUG$EXECUTE)
          yell("Execute: [%d] DONE", exe_level);
        return;
      }
    }
    command = find_command(command_list, NUMBER_OF_COMMANDS, word, &cmd_cnt);

    if (cmd_cnt == 0)
      say("*** Command %s is not known.", word);
    else if (((cmd_cnt < 0) || (cmd_cnt == 1)) && command) {
      command->cmdfcn(string, command->varpar, param);
    } else
      say("*** Command %s is ambiguous.", word);
    if (getivar("DISPLAY")==-1) setivar("DISPLAY", olddisplay);
    if (getivar("DEBUG") & DEBUG$EXECUTE)
      yell("Execute: [%d] DONE", exe_level);
    return;
  }
  if ((outuser = getquery())) send_msg(outuser, string);
  else send_chan(string);
  if (getivar("DISPLAY")==-1) setivar("DISPLAY", olddisplay);
}
